/**
 **
 ** MultipleExtensionsFileFilter.java - File filter accepting multiple filename extensions
 **
 ** Copyright (C) 2019 Elphel, Inc.
 **
 ** -----------------------------------------------------------------------------**
 **
 **  MultipleExtensionsFileFilter.java is free software: you can redistribute it and/or modify
 **  it under the terms of the GNU General Public License as published by
 **  the Free Software Foundation, either version 3 of the License, or
 **  (at your option) any later version.
 **
 **  This program is distributed in the hope that it will be useful,
 **  but WITHOUT ANY WARRANTY; without even the implied warranty of
 **  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 **  GNU General Public License for more details.
 **
 **  You should have received a copy of the GNU General Public License
 **  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 ** -----------------------------------------------------------------------------**
 **
 */
package com.elphel.imagej.calibration;

import java.io.File;
import java.io.FilenameFilter;

import javax.swing.filechooser.FileFilter;

/* ======================================================================== */
  public class MultipleExtensionsFileFilter extends FileFilter implements FilenameFilter {
	  protected String [] patterns; // case insensitive
	  protected String    description="JP4 files";
	  protected String [] prefixes= {""}; // case sensitive


	  // prefix/prefixeas can not be null - ambiguity
	  public MultipleExtensionsFileFilter (String prefix, String [] patterns,String description) {
		  this.prefixes=     new String[1];
		  this.prefixes[0] = prefix;
		  this.description=description;
		  this.patterns=   patterns.clone();
	  }
	  public MultipleExtensionsFileFilter (String [] prefixes, String [] patterns,String description) {
		  this.prefixes=   prefixes;
		  this.description=description;
		  this.patterns=   patterns.clone();
	  }

	  public MultipleExtensionsFileFilter (String [] patterns,String description) {
		  this.description=description;
		  this.patterns=patterns.clone();
	  }
	  public MultipleExtensionsFileFilter (String [] patterns) {
		  this.patterns=patterns.clone();
	  }
	  @Override
	  public boolean accept (File file) {
		  int i;
		  String name=file.getName();
		  if (file.isDirectory()) return true;
		  if (!testPrefix(name)) return false;
		  for (i=0;i<patterns.length;i++) {
			  if (name.toLowerCase().endsWith(patterns[i].toLowerCase())) return true;
		  }
		  return false;
	  }
	  @Override
	public boolean accept (File dir, String name) { // directory - don't care here, only name
		  if (!testPrefix(name)) return false;
		  for (int i=0;i<patterns.length;i++) {
			  if (name.toLowerCase().endsWith(patterns[i].toLowerCase())) return true;
		  }
		  return false;
	  }
	  @Override
	public String getDescription() {
		  return description;
	  }
	  private boolean testPrefix(String name) {
		  if ((prefixes == null) || (prefixes[0] == null)) return true;
		  for (String s : prefixes) {
			  if ((s == null) || name.startsWith(s)) {
				  return true;
			  }
		  }
		  return false; // prefix mismatch;
	  }
  }